﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;
using Infragistics.Windows;

namespace SeriesZOrder
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = Data.GetData(10, 20, 40);
        }

        private void comboBox1_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            Series series = comboBox1.SelectedItem as Series;

            for (int i = 0; i < xamDataChart1.Series.Count; i++)
            {
                if (i != xamDataChart1.Series.IndexOf(series))
                    Panel.SetZIndex(xamDataChart1.Series[i], i);
                else
                    Panel.SetZIndex(xamDataChart1.Series[i], xamDataChart1.Series.Count);
            }            
        }

        private void chbPriceSeriesVisibility_Checked(object sender, RoutedEventArgs e)
        {
            Series series = ((sender as RadioButton).DataContext as DataContext).Series as Series;
            XamDataChart chart = Utilities.GetAncestorFromType(((sender as RadioButton).DataContext as DataContext).Series, typeof(XamDataChart), false) as XamDataChart;

            for (int i = 0; i < chart.Series.Count; i++)
            {
                if (i != chart.Series.IndexOf(series))
                    Panel.SetZIndex(chart.Series[i], i);
                else
                    Panel.SetZIndex(chart.Series[i], xamDataChart1.Series.Count);
            } 
        }

    }

    public class Data : INotifyPropertyChanged
    {
        private double open;
        private double close;
        private double high;
        private double low;
        private double value;
        private string label;
        private DateTime date;


        public DateTime Date
        {
            get { return date; }
            set
            {
                date = value;
                PropChanged("Date");
            }
        }


        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public double Open
        {
            get { return open; }
            set
            {
                open = value;
                PropChanged("Open");
            }
        }

        public double Close
        {
            get { return close; }
            set
            {
                close = value;
                PropChanged("Close");
            }
        }

        public double High
        {
            get { return high; }
            set
            {
                high = value;
                PropChanged("High");
            }
        }

        public double Low
        {
            get { return low; }
            set
            {
                low = value;
                PropChanged("Low");
            }
        }

        public double Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }

        public double Avarage
        {
            get
            {
                return (Open + Close + High + Low) / 4;
            }
        }

        public static ObservableCollection<Data> GetData(int podoubles, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (double i = 0; i < podoubles; i++)
            {
                double val = r.Next(rangeStart, rangeEnd);

                data.Add(new Data
                {
                    Date = DateTime.Now.AddDays(i),
                    Label = "Item " + i,
                    Open = val + r.NextDouble(),
                    Close = val + r.NextDouble(),
                    High = val + r.NextDouble(),
                    Low = val + r.NextDouble(),
                    Value = val + r.NextDouble(),
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
